import stiftUndCo.*;


public class NDamen extends EreignisAnwendung
{

	private int[] plazierung; 
	private int anzahlDamen;
	private int anzahlLsungen;
	
	public NDamen(int anzahl)
	{

		super(300,200,"Das n-Damen-Problem");
		int i;
		plazierung = new int[anzahl+1];
		anzahlDamen=anzahl;
		for ( i=1; i<= anzahl;i=i+1)
		{
			plazierung[i]=0;
		} // Ende for			
	} // Ende Konstruktor NDamen

	public void bearbeiteMausDruck(int x, int y)
	{
		this.gitter();
		anzahlLsungen=0;
		this.such(1);
		this.stift().bewegeBis(150,100);
		this.stift().normal();
		this.stift().schreibe(""+anzahlLsungen);	
	} // Ende bearbeiteMausDruck

	public void zeichneDame(int i, int j)
	{
		this.stift().bewegeBis(10*i,10*j+30);
		this.stift().normal();
		this.stift().zeichneKreis(4);
	} // Ende zeichneDame

	public void loescheDame(int i, int j)
	{
		this.stift().bewegeBis(10*i,10*j+30);
		this.stift().radiere();
		this.stift().zeichneKreis(4);
	}// Ende loescheDame

	private void gitter()
	{ int i;
		for (i=0; i<= anzahlDamen; i=i+1)
		{
			this.stift().normal();
			this.stift().hoch();
			this.stift().bewegeBis(10*i+5,35);
			this.stift().runter();
			this.stift().bewegeBis(10*i+5,35+anzahlDamen*10);
			this.stift().hoch();

		} // Ende for
		for (i=0; i<= anzahlDamen; i=i+1)
		{
			this.stift().normal();
			this.stift().hoch();
			this.stift().bewegeBis(5,10*i+35);
			this.stift().runter();
			this.stift().bewegeBis(anzahlDamen*10+5,10*i+35);
			this.stift().hoch();

		} // Ende for
	} // Ende gitter


	private void such(int i)
	{   int j;
		for (j=1;j<=anzahlDamen;j=j+1)
		{
			if (this.passt(i,j))
			{
				plazierung[i]=j;
				this.zeichneDame(i,j);

				if (i==anzahlDamen)  // Lsung ist gefunden
				{
					anzahlLsungen=anzahlLsungen+1;
				} 
				else 
				{ 
					such(i+1); // weiter mit der nchsten Dame
				} // Ende if

				this.loescheDame(i,j);
			} // Ende if
		} // Ende for
	} // Ende such



	private boolean passt(int i, int j)
	{
		boolean hilf, ende;
		int k;
		hilf=true;
		ende=false;
		k=1;		
		
		if (i==1) 
		{
			return true;
		} // Ende if
		// pat die i-Dame auf Zeile j ?
		while (hilf && ! ende)
		{
			hilf = (plazierung[k]!=j) ;
			k=k+1;
			ende = (k==i);
		} // Ende while
		// berprfung der absteigenden Diagonalen
		ende=false;
		k=1;
		while (hilf && ! ende)
		{
			hilf = (plazierung[k]-k!=j-i) ;
			k=k+1;
			ende = (k==i);
		} // Ende while
		// berprfung der aufsteigenden Diagonalen
		ende=false;
		k=1;
		while (hilf && ! ende)
		{
			hilf = (plazierung[k]+k!=j+i) ;
			k=k+1;
			ende = (k==i);
		} // Ende while
		return hilf;
	}


} // Ende NDamen

