import stiftUndCo.*;
import java.awt.*;
//
//
// GrafikObjekt
//
//
public abstract class GrafikObjekt 
{
	private BuntStift meinStift;
	private boolean zsichtbar=false;
    private Color zfarbe;
	private Color aktivFarbe=Farbe.ROT;
	private Color aktuelleFarbe;
    private boolean zaktiv;
    private char ztaste;
	private boolean zbeweglich;
	private double zaltx,zalty;
	private MalFenster bi=null;
    
	public GrafikObjekt()
	{
        bi= DasFenster.hauptFenster;
		meinStift= new BuntStift();
		zfarbe=Farbe.SCHWARZ;
		aktuelleFarbe=zfarbe;
		zsichtbar=false;
		zaktiv=false;
		zbeweglich=true;
		ztaste='@';
	}

    



	public abstract void bewegeUm(double dx, double dy);

	public abstract void  zeige();

	public abstract void  loesche();

	public abstract boolean istDrin(double px, double py);

    public void gibFrei()
	{
	   this.setzeSichtbar(false);
	   meinStift.gibFrei();
       meinStift=null;
	}

	public final void setzeFarbe(Color pf)
	{
		if (zsichtbar) 
		{
			this.setzeSichtbar(false);
			zfarbe=pf;
			aktuelleFarbe=zfarbe;
			this.setzeSichtbar(true);
		}
		else
		{
			zfarbe=pf;
			aktuelleFarbe=zfarbe;
		}
	}


	public final Color farbe()
	{
		return aktuelleFarbe;
	}
	

	public final void update()
	{ 
		if (zsichtbar) {this.zeige();}
	}

	public final void setzeSichtbar(boolean s)
	{
		if (zsichtbar && (!s)) { this.loesche(); }
		else
		{ if (s) {  this.zeige();} }
		zsichtbar=s;
		if (s && (bi != null)) {bi.aktualisiere();} 
	}

	public final boolean sichtbar()
	{
		return zsichtbar;
	}

	public final BuntStift stift()
	{
		return meinStift;
	}
	

	public final void aktiviere()
	{
		if (zsichtbar) 
		{
			this.setzeSichtbar(false);
			zaktiv=true;
			aktuelleFarbe=aktivFarbe;
			this.setzeSichtbar(true);
		}
		else
		{
			zaktiv=true;
			aktuelleFarbe=aktivFarbe;
		}
	}

	public final void deaktiviere()
	{
		if (zsichtbar) 
		{
			this.setzeSichtbar(false);
			zaktiv=false;
			aktuelleFarbe=zfarbe;
			this.setzeSichtbar(true);
		}
		else
		{
			zaktiv=false;
			aktuelleFarbe=zfarbe;
		}
	}

	public final void aktivndern()
	{
		if (zaktiv) { this.deaktiviere();} else { this.aktiviere();}
	}

	public final boolean aktiv()
	{
		return zaktiv;
	}
	public final void setzeTaste(char t)
	{
		ztaste=t;
	}

	public final char taste()
	{
		return ztaste;
	}

	public void wertePositionAus(double px, double py)
	{
		if (this.istDrin(px,py)) 
		{ 
			this.aktiviere(); 
		}
		else
		{
			this.deaktiviere();
		}
	}

	

	public void werteTasteAus(char pt)
	{
		if ( pt==ztaste ) 
		{
			this.aktivndern();
		}
		if ( zaktiv && zbeweglich ) 
		{
			switch  (pt) 
			{
				case Zeichen.PFEILOBEN : this.bewegeUm(0,-1); break;
				case Zeichen.PFEILUNTEN: this.bewegeUm(0,1); break;
				case Zeichen.PFEILRECHTS: this.bewegeUm(1,0); break;
				case Zeichen.PFEILLINKS:  this.bewegeUm(-1,0); break;
			}
		}
	}

	public final void setzeBeweglich(boolean pb)
	{
		zbeweglich=pb;
	}

	public final boolean beweglich()
	{
        return zbeweglich;
	}

	public void reagiereAufMausDruck(double x, double y)
	{
		this.wertePositionAus(x,y);
		zaltx=x;
		zalty=y;
	}


	public final void  reagiereAufMausBewegt(double x, double y)
	{
		if ( zaktiv && zbeweglich ) 
		{
			this.bewegeUm(x-zaltx,y-zalty);
			zaltx=x;zalty=y;
		}
	}

	public final void  reagiereAufMausLos(double x, double y)
	{
		this.deaktiviere();
	}

	

}

