import stiftUndCo.*;
import java.awt.*;
import java.awt.event.*;
//
//
// Hanoi Version fr Java 1.1
// Georg Dick 9.6.1998
// berarbeitet 19.7.98
//
//
public class Hanoi extends EreignisAnwendung implements ActionListener
{

	private Turm[] turm;
	private Keller opstack;
	private int anzahl,zugzahl=0;
	private double scheibenhoehe;
	private double turmbasis,turmbreite,turmmitte;
	private boolean zanimation=false;
	private boolean demoModus=false;
	private Button bdemo,bende,bspiel,bschnell,blangsam;
	private TextField scheibenzahl;
	private double geschwindigkeit=0.1; // >0 und je kleiner desto schneller :-)

	public static void main (String[] s)
	{
		Hanoi h = new Hanoi(5);
		h.fhreAus();
	}

	public Hanoi(int anzahl)
	{   
		super(400,350,"Trme von Hanoi");
		this.bildschirm().setzeHintergrundmodus(true);
		this.bildschirm().add(bdemo=new Button("Demo"));
		bdemo.addActionListener(this);
		this.bildschirm().add(bspiel=new Button("Spiel"));
		bspiel.addActionListener(this);
		this.bildschirm().add(scheibenzahl=new TextField(5));
		scheibenzahl.addActionListener(this);
		this.bildschirm().add(bende=new Button("Ende"));
		bende.addActionListener(this);
		this.bildschirm().add(bschnell=new Button("+"));
		bschnell.addActionListener(this);
		this.bildschirm().add(blangsam=new Button("-"));
		blangsam.addActionListener(this);
		this.bildschirm().validate();
		this.bildschirm().show();
		this.anzahl=anzahl;
		stift().hoch();
		stift().radiere();
		stift().bewegeBis(2,bildschirm().hoehe()-1);
		stift().schreibe("Demomodus: Mausklick = ein Schritt");			
		stift().schreibe(";Taste = zehn Schritte");
		stift().normal();
		stift().bewegeBis(2,bildschirm().hoehe()-1);
		stift().schreibe("Spielmodus: Ziehe obere Scheibe mit der Maus");			
		demoModus=false;
		this.neu(anzahl);
		
	}
	

	public void trmeUndStackLschen()
	{
			for (int i=0; i<3;i++)
			{
				if (turm[i] != null ) {turm[i].gibFrei();}
			}
			opstack=null;
	}

	public void spielAktion()
	{	stift().hoch();
		stift().radiere();
		stift().bewegeBis(2,bildschirm().hoehe()-1);
		stift().schreibe("Demomodus: Mausklick = ein Schritt");			
		stift().schreibe(";Taste = zehn Schritte");
		stift().normal();
		stift().bewegeBis(2,bildschirm().hoehe()-1);
		stift().schreibe("Spielmodus: Ziehe obere Scheibe mit der Maus");			
		demoModus=false;
		this.trmeUndStackLschen();			
		this.neu(anzahl);
		bildschirm().aktualisiere();
	}

 	public void demoAktion()
	{
		demoModus=true;
	    // Stift zeigt an, da jetzt demomodus aktiv ist
		this.trmeUndStackLschen();			
		this.neu(anzahl);
		stift().hoch();
		stift().radiere();
		stift().bewegeBis(2,bildschirm().hoehe()-1);
		stift().schreibe("Spielmodus: Ziehe obere Scheibe mit der Maus");			
		stift().normal();
		stift().bewegeBis(2,bildschirm().hoehe()-1);
		stift().schreibe("Demomodus: Mausklick = ein Schritt");			
		stift().schreibe(";Taste = zehn Schritte");
		bildschirm().aktualisiere();
		this.bildschirm().requestFocus();
	}

	public void actionPerformed(ActionEvent e)
	{
		//System.out.println("Aktion");
		//Reaktion auf Knopf Demo
		String knopfKommando=e.getActionCommand();
		if (knopfKommando.equals("Demo"))
		{ 
			this.demoAktion();
		} else
		
		if (knopfKommando.equals("+"))
		{ 
			if (geschwindigkeit >0.002) {geschwindigkeit=0.5*geschwindigkeit;}
			this.bildschirm().requestFocus();
		} else
		
		if (knopfKommando.equals("-"))
		{ 
			if (geschwindigkeit < 4.) {geschwindigkeit=2.*geschwindigkeit;}
		     this.bildschirm().requestFocus();

		} else
		if (knopfKommando.equals("Ende"))
		{ 
			this.trmeUndStackLschen();
			this.beenden();
		} else

		
		if (knopfKommando.equals("Spiel"))
		{ 
			spielAktion();
		} else

		
		{   
			try {
				  anzahl=Integer.valueOf(knopfKommando).intValue();
			}
			catch (Exception ex)
			{
				;
			}
			if (anzahl<0) {anzahl=1;}
			this.bildschirm().requestFocus();

		}
		
		
	}



	public void lscheZugZahl()
	{
		stift().hoch();
		stift().bewegeBis(2,bildschirm().hoehe()-12);
		stift().normal();
		stift().schreibe("Zge:");
		stift().radiere();
		stift().schreibe(""+zugzahl);
		bildschirm().aktualisiere();
	}
	public void zeigeZugZahl()
	{
		stift().bewegeBis(2,bildschirm().hoehe()-12);
		stift().normal();
		stift().schreibe("Zge:"+zugzahl);
		bildschirm().aktualisiere();
	}

	public void erhheZugZahl()
	{
		this.lscheZugZahl();
		zugzahl++;
		this.zeigeZugZahl();
	}

	public void neu(int anzahl)
	{
		int i;
		this.lscheZugZahl();
		zugzahl=0;
		this.zeigeZugZahl();
		Scheibe hilf,s;
		turm=new Turm[3];
		this.anzahl=anzahl;
		scheibenhoehe=(this.bildschirm().hoehe()-anzahl*2-20)/(anzahl+5);
		turmbasis=this.bildschirm().hoehe()-scheibenhoehe-20;
		turmmitte=this.bildschirm().breite()/4;
		turmbreite=this.bildschirm().breite()/5.+17;
		for (i=0;i<=2;i++)
		{ 
			turm[i]=new Turm((i+1)*turmmitte-turmbreite/2,turmbasis,turmbreite);
		}

		for (i=0;i<anzahl;i++)
		{
			s = new Scheibe();
			s.setzeFarbe(Farbe.BLAU);
			s.setzeBreite((anzahl-i)*this.bildschirm().breite()/(5.*anzahl)); 
			s.setzeHoehe(scheibenhoehe);         
			// s richtet sich nach darunterliegender Scheibe aus
			s.richteAus((Scheibe)turm[0].top());					
			s.setzeSichtbar(true);
			turm[0].push(s);		
						
		}
		// this.bewege(anzahl,0,2,1); // rekursive Vorgehensweise
		this.starteStack(anzahl);
		bildschirm().aktualisiere();
	}
	
	public void bearbeiteMausDruck(int x, int y)
	{
		if (demoModus)
		{
			if (! opstack.empty())
			{
				zanimation=true;
				this.naechsterSchritt();
				this.erhheZugZahl();
			}
		} else
		{
			for (int i=0; i<=2; i++)
			{
				if (turm[i].anzahlScheiben()>0)
				 ((Scheibe)turm[i].top()).reagiereAufMausDruck(x,y);

			}
		}
		
	}

	public void bearbeiteMausLos(int x, int y)
	{
		Scheibe s;
		boolean gefunden;
		
		
		if (! demoModus)
		{
			gefunden=false;
			for (int i=0; i<=2; i++)
			{
				if (turm[i].anzahlScheiben()>0 && ((Scheibe)turm[i].top()).aktiv())
				{
					s=(Scheibe)turm[i].top();
				 	turm[i].pop();
					// nchstgelegenen Turm bestimmen und Scheibe umlegen
					for (int j=0; j<=2; j++)
					if (turm[j].istDrin(s.hPosition()+s.breite()/2.)
						&& ((Scheibe)turm[j].top()).breite()> s.breite())
					{
						s.richteAus((Scheibe)turm[j].top(),true,geschwindigkeit);
						turm[j].push(s);
						gefunden=true;
						if (i != j) { this.erhheZugZahl();}
					}
					if (! gefunden)
					{
						s.richteAus((Scheibe)turm[i].top(),true,geschwindigkeit);
						turm[i].push(s);
					}
				}
			}
		}
		
	}

	public void bearbeiteTaste(char t)
	{	
		
		if (demoModus)
		{
			for (int i=0;i <10; i++)
			if (! opstack.empty())
			{
				zanimation=true;
				this.naechsterSchritt();
				this.erhheZugZahl();
			}
		}
	}

	public void bearbeiteMausBewegt(int x, int y)
	{
		if (! demoModus)
		{
			for (int i=0; i<=2; i++)
			{
				try {
				((Scheibe)turm[i].top()).reagiereAufMausBewegt(x,y);
				}
				catch (Exception e) {;}
			}
		}
		
	}

	public void starteStack(int anzahl)
	{
		opstack=null; // gegebenenfalls alten Stack freigeben
		TurmOperation start=new TurmOperation(anzahl,0,2);
		opstack = new Keller();
		opstack.push(start);
	}

	public void naechsterSchritt()
	{
		TurmOperation otop,o;
		if (! opstack.empty())
		{
			otop = (TurmOperation)opstack.top();
			while ( otop.anzahl()>1 )
			{
				opstack.pop();
				o=new TurmOperation(otop.anzahl()-1,3-otop.von()-otop.nach(),otop.nach());
				opstack.push(o);
				o=new TurmOperation(1,otop.von(),otop.nach());
				opstack.push(o);
				o=new TurmOperation(otop.anzahl()-1,otop.von(),3-otop.von()-otop.nach());
				opstack.push(o);
				otop=o;		
			}
			this.legeScheibeUm(otop.von(),otop.nach());
			opstack.pop();
			otop=null;
		}
	}


	
	
	public void legeScheibeUm(int von, int nach)
	{
	// Scheibe von "Von" nach "nach"
		
		((Scheibe)turm[von].top()).richteAus((Scheibe)turm[nach].top(),zanimation,geschwindigkeit);
		turm[nach].push(turm[von].top());
		turm[von].pop();
	}


// rekursive Lsung
public void bewege(int soviele, int von, int nach, int ber)
{
	// Turm der Hhe soviele-1 von "von" nach "ber" bewegen
	if (soviele > 1) { this.bewege(soviele-1,von,ber,nach);}
	
	this.legeScheibeUm(von,nach);

	// Turm der Hhe soviele-1 von "ber" nach "nach" bewegen
	if (soviele > 1) { this.bewege(soviele-1,ber,nach,von);}
}

}

